// +build !generate_numeric

package hit

import minitest "github.com/Eun/go-hit/internal/minitest"

// ⚠️⚠️⚠️ This file was autogenerated by generators/expect/numeric ⚠️⚠️⚠️ //

// IExpectInt8 provides assertions for the int8 type.
type IExpectInt8 interface {
	// Equal expects the int8 to be equal to the specified value.
	Equal(value int8) IStep

	// NotEqual expects the int8 to be not equal to the specified value.
	NotEqual(value ...int8) IStep

	// OneOf expects the int8 to be equal to one of the specified values.
	OneOf(values ...int8) IStep

	// NotOneOf expects the int8 to be not equal to one of the specified values.
	NotOneOf(values ...int8) IStep

	// GreaterThan expects the int8 to be not greater than the specified value.
	GreaterThan(value int8) IStep

	// LessThan expects the int8 to be less than the specified value.
	LessThan(value int8) IStep

	// GreaterOrEqualThan expects the int8 to be greater or equal than the specified value.
	GreaterOrEqualThan(value int8) IStep

	// LessOrEqualThan expects the int8 to be less or equal than the specified value.
	LessOrEqualThan(value int8) IStep

	// Between expects the int8 to be between the specified min and max value (inclusive, min >= int8 >= max).
	Between(min, max int8) IStep

	// NotBetween expects the int8 to be not between the specified min and max value (inclusive, min >= int8 >= max).
	NotBetween(min, max int8) IStep
}
type expectInt8ValueCallback func(hit Hit) int8
type expectInt8 struct {
	cp            callPath
	valueCallback expectInt8ValueCallback
}

func newExpectInt8(cp callPath, valueCallback expectInt8ValueCallback) IExpectInt8 {
	return &expectInt8{cp: cp, valueCallback: valueCallback}
}
func (v *expectInt8) Equal(value int8) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("Equal", []interface{}{value}), Exec: func(hit *hitImpl) error {
		return minitest.Equal(v.valueCallback(hit), value)
	}}
}
func (v *expectInt8) NotEqual(values ...int8) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("NotEqual", int8SliceToInterfaceSlice(values)), Exec: func(hit *hitImpl) error {
		return minitest.NotEqual(v.valueCallback(hit), int8SliceToInterfaceSlice(values)...)
	}}
}
func (v *expectInt8) OneOf(values ...int8) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("OneOf", int8SliceToInterfaceSlice(values)), Exec: func(hit *hitImpl) error {
		return minitest.OneOf(v.valueCallback(hit), int8SliceToInterfaceSlice(values)...)
	}}
}
func (v *expectInt8) NotOneOf(values ...int8) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("NotOneOf", int8SliceToInterfaceSlice(values)), Exec: func(hit *hitImpl) error {
		return minitest.NotOneOf(v.valueCallback(hit), int8SliceToInterfaceSlice(values)...)
	}}
}
func (v *expectInt8) GreaterThan(value int8) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("GreaterThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l <= value {
			return minitest.Errorf("expected %d to be greater than %d", l, value)
		}
		return nil
	}}
}
func (v *expectInt8) LessThan(value int8) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("LessThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l >= value {
			return minitest.Errorf("expected %d to be less than %d", l, value)
		}
		return nil
	}}
}
func (v *expectInt8) GreaterOrEqualThan(value int8) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("GreaterOrEqualThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l < value {
			return minitest.Errorf("expected %d to be greater or equal than %d", l, value)
		}
		return nil
	}}
}
func (v *expectInt8) LessOrEqualThan(value int8) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("LessOrEqualThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l > value {
			return minitest.Errorf("expected %d to be less or equal than %d", l, value)
		}
		return nil
	}}
}
func (v *expectInt8) Between(min, max int8) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("Between", []interface{}{min, max}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l < min || l > max {
			return minitest.Errorf("expected %d to be between %d and %d", l, min, max)
		}
		return nil
	}}
}
func (v *expectInt8) NotBetween(min, max int8) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("NotBetween", []interface{}{min, max}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l >= min && l <= max {
			return minitest.Errorf("expected %d not to be between %d and %d", l, min, max)
		}
		return nil
	}}
}
